#!/bin/bash
export PATH=/bin:/sbin:/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/sbin:$PATH

: '
Copyright (C) 2022 - now  HaoZi Technology Co., Ltd.

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published
by the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program.  If not, see <https://www.gnu.org/licenses/>.
'

source <(curl -f -s --connect-timeout 10 --retry 3 https://dl.cdn.haozi.net/panel/public.sh)
if [ $? -ne 0 ]; then
    echo "下载 public.sh 失败,请检查网络或稍后重试。"
    echo "Download public.sh failed, please check the network or try again later."
    exit 1
fi

channel=${1}
version=${2}
frp_path="${setup_path}/server/frp"

if [ ! -d "${frp_path}" ]; then
    mkdir -p ${frp_path}
fi

# 架构判断
if [ ${ARCH} == "x86_64" ]; then
    frp_file="frp_${version}_linux_amd64.7z"
elif [ ${ARCH} == "aarch64" ]; then
    frp_file="frp_${version}_linux_arm64.7z"
else
    error "不支持的架构"
fi

# 下载frp
cd ${frp_path}
wget --retry-connrefused --retry-on-host-error --retry-on-http-error=429,500,502,503,504 -t 10 -T 120 -O ${frp_path}/${frp_file} ${download_url}/frp/${frp_file}
wget --retry-connrefused --retry-on-host-error --retry-on-http-error=429,500,502,503,504 -t 10 -T 120 -O ${frp_path}/${frp_file}.sha256 ${download_url}/frp/${frp_file}.sha256
if ! sha256sum --status -c ${frp_path}/${frp_file}.sha256; then
    rm -rf ${frp_path}
    error "frp 校验失败"
fi

# 解压frp
cd ${frp_path}
7z x ${frp_file}
chown -R www:www ${frp_path}
chmod -R 700 ${frp_path}
rm -f ${frp_file} ${frp_file}.sha256

# 配置systemd
cat >/etc/systemd/system/frps.service <<EOF
[Unit]
Description=Frp Server Service
After=network.target syslog.target
Wants=network.target

[Service]
User=www
Group=www
Type=simple
Restart=on-failure
RestartSec=5s
ExecStart=${setup_path}/server/frp/frps -c ${setup_path}/server/frp/frps.toml

[Install]
WantedBy=multi-user.target
EOF

cat >/etc/systemd/system/frpc.service <<EOF
[Unit]
Description=Frp Client Service
After=network.target syslog.target
Wants=network.target

[Service]
User=www
Group=www
Type=simple
Restart=on-failure
RestartSec=5s
ExecStart=${setup_path}/server/frp/frpc -c ${setup_path}/server/frp/frpc.toml

[Install]
WantedBy=multi-user.target
EOF

chmod 644 /etc/systemd/system/frps.service
chmod 644 /etc/systemd/system/frpc.service

systemctl daemon-reload
systemctl enable --now frps
if [ "$?" != "0" ]; then
    error "启动失败"
fi
systemctl enable --now frpc
if [ "$?" != "0" ]; then
    error "启动失败"
fi

panel-cli app write frp ${channel} ${version}

echo -e ${HR}
echo "安装完成"
echo -e ${HR}